import { Meta, Canvas, Story } from '@storybook/addon-docs'
import { Layers } from '../../sources/stories/MSourceGeojson.stories.js'

<Meta title="Layers/Readme" />

# Layers

Layer components are rendering the data on the map.
They are childs of source components.

`<m-layer-background>`<br />
To change the background, it's the only layer that does not need the be a child of a source.<br />
`import { MLayerBackground } from '@atlastories.app/vue-maplibre'`

`<m-layer-circle>`<br />
To display a circle<br />
`import { MLayerCircle } from '@atlastories.app/vue-maplibre'`

`<m-layer-fill>`<br />
To display polygons<br />
`import { MLayerFill } from '@atlastories.app/vue-maplibre'`

`<m-layer-fill-extrusion>`<br />
To display 3D extrusions<br />
`import { MLayerFillExtrusion } from '@atlastories.app/vue-maplibre'`

`<m-layer-heatmap>`<br />
To display heatmaps<br />
`import { MLayerHeatmap } from '@atlastories.app/vue-maplibre'`

`<m-layer-hillshade>`<br />
To display shadows from hills and terrain elevation (set `terrain` prop to false to avoid elevation 3D)<br />
`import { MLayerHillshade } from '@atlastories.app/vue-maplibre'`

`<m-layer-line>`<br />
To display lines<br />
`import { MLayerLine } from '@atlastories.app/vue-maplibre'`

`<m-layer-raster>`<br />
Child of `<m-source-raster>` for rater tiles, `<m-source-image>` or `<m-source-video>` to render bitmap<br />
`import { MLayerRaster } from '@atlastories.app/vue-maplibre'`

`<m-layer-symbol>`, `<m-layer-symbol-icon>` and `<m-layer-symbol-text>`<br />
To display icon and text<br />
`import { MLayerSymbol, MLayerSymbolIcon, MLayerSymbolText } from '@atlastories.app/vue-maplibre'`

Multiple layers can render different data from the same source.
In the following example the layer line and layer circle have the same geojson source, filtered.

```
<m-source-geojson>
  <m-layer-fill :filter="['==', '$type', 'Polygon']" />
  <m-layer-circle :filter="['==', '$type', 'Point']" />
</m-source-geojson>
```

## Layer cake

To make sure a layer is on top of another, use the properties `id` and `before`

```
<m-source-geojson>
  <m-layer-circle id="points" />
  <m-layer-fill before="points" />
</m-source-geojson>
```

<Canvas>
  <Story
    name="Layers">
    {Layers.bind({})}
   </Story>
</Canvas>

## Events

Here is the list of events you can observe on layers:

- mounted
- mouseenter
- mouseleave
- mousedown
- mouseup
- mouseover
- mouseout
- mousemove
- click
- dblclick
- contextmenu
- touchstart
- touchend
- touchcancel

`mounted` is fired when the layer has been added to the map, it returns the layer instance

## Feature clicked

A common use case is to use data from the feature clicked on a layer.

```
<script setup>
const refMap = ref(null)
const onClick = e => {
  const features = refMap.value.map.queryRenderedFeatures(e.point)
  const feature = features[0] // feature clicked
  ...
}
</script>

<template>
  <m-map ref="refMap">
    <m-source-geojson>
      <m-layer-circle @click="onClick" />
    </m-source-geojson>
  </m-map>
</template>
```

## Symbol layer

The symbol layer has two children, one for the text, the other for the icon.
Event are observable on the `<m-layer-symbol>` while `<m-layer-symbol-text>`
and `<m-layer-symbol-icon>` are only used to display.

```
<m-layer-symbol>
  <m-layer-symbol-text />
  <m-layer-symbol-icon />
</m-layer-symbol>
```
<Canvas>
  <Story id="layers-mlayersymboltext--example" />
</Canvas>
